"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var audio_graph_1 = require("./audio-graph");
var AudioBufferQueueNode = /** @class */ (function () {
    function AudioBufferQueueNode(audioGraph, audioFile) {
        this.scriptProcessorNode = audioGraph.audioContext.createScriptProcessor(audio_graph_1.default.BUFFER_SIZE, 0, 1);
        this.scriptProcessorNode.addEventListener('audioprocess', function (e) {
            var out = e.outputBuffer;
            var chunk = audioFile.signalDataModifiedChunked[audioGraph.getBufferIndex()];
            if (!audioGraph.readOnlyIsLooping) {
                audioGraph.updateBufferIndex(1, audioFile);
            }
            out.copyToChannel(chunk, 0);
        });
    }
    AudioBufferQueueNode.prototype.connect = function (args) {
        return this.scriptProcessorNode.connect.call(this.scriptProcessorNode, args);
    };
    AudioBufferQueueNode.prototype.disconnect = function (args) {
        return this.scriptProcessorNode.disconnect.call(this.scriptProcessorNode, args);
    };
    return AudioBufferQueueNode;
}());
exports.default = AudioBufferQueueNode;
//# sourceMappingURL=audio-buffer-queue-node.js.map