import AudioGraph from './audio-graph';
export default class AudioFile {
    static CHANNEL: number;
    private numToLinearSmooth;
    private bufferSize;
    private entireFileAsAudioBuffer;
    private signalDataChunked;
    private audioGraph;
    chunkedFfts: Float32Array[];
    signalDataModifiedChunked: Float32Array[];
    numFullBuffers: number;
    constructor(audioGraph: AudioGraph, entireBuffer: AudioBuffer, bufferSize: number, numToLinearSmooth: number);
    makeNewChunkedArray(processor: Function): Float32Array[];
    process(): void;
    makeSignalDataChunked(): void;
    makeSignalDataModifiedChunked(): void;
    makeChunkedFfts(): void;
    static spaceValues(startValueInclusive: number, endValueExclusive: number, valuesToFit: number): number[];
}
