import AudioBufferQueueNode from './audio-buffer-queue-node';
import AudioFile from './audio-file';
import { AudioGraphStatus } from '../common/types';
export default class AudioGraph {
    static BUFFER_SIZE: number;
    private bufferIndex;
    readOnlyIsLooping: boolean;
    audioContext: AudioContext;
    gainNode: GainNode;
    specialNode: AudioBufferQueueNode;
    oscillatorNode: OscillatorNode;
    private distributeNewBufferIndex;
    constructor(distributeNewBufferIndex: (newIndex: number) => void);
    buildNodes(audioFile: AudioFile): void;
    connectNodes(): AudioGraphStatus;
    resetGraphToDefaultState(): AudioGraphStatus;
    disconnectAllNodes(): AudioGraphStatus;
    updateBufferIndex(increment: number, audioFile: AudioFile): void;
    getBufferIndex(): number;
    setReadOnlyIsLooping(isLooping: boolean): void;
}
