"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_dropzone_1 = require("react-dropzone");
var DEFAULT_DROPZONE_MESSAGE = 'Drop .wav here...';
var FileLoader = /** @class */ (function (_super) {
    __extends(FileLoader, _super);
    function FileLoader(props) {
        var _this = _super.call(this, props) || this;
        _this.handleOnDrop = function (acceptedFiles, rejectedFiles) {
            if (rejectedFiles.length > 0 || acceptedFiles.length > 1) {
                _this.setState({ dropzoneText: 'You may drop in only one .wav file.' });
                return;
            }
            var reader = new FileReader();
            reader.onload = function () {
                _this.setState({ dropzoneText: DEFAULT_DROPZONE_MESSAGE });
                _this.props.handleLoadFile(reader.result);
                return;
            };
            reader.onerror = function () {
                _this.setState({ dropzoneText: 'For whatever reason, this file could not be read.' });
                return;
            };
            reader.onabort = function () {
                _this.setState({ dropzoneText: 'File reading was aborted.' });
                return;
            };
            reader.readAsArrayBuffer(acceptedFiles[0]);
        };
        _this.state = {
            dropzoneText: DEFAULT_DROPZONE_MESSAGE
        };
        return _this;
    }
    FileLoader.prototype.render = function () {
        var positionClass = this.props.normalVisualizationStyle
            ? 'ffb-fileLoader-topRight'
            : 'ffb-fileLoader-bottomLeft';
        var dropzoneErrorClass = this.state.dropzoneText !== DEFAULT_DROPZONE_MESSAGE
            ? 'ffb-fileLoader-dropzone--error'
            : null;
        return (React.createElement(react_dropzone_1.default, { className: "ffb-fileLoader " + positionClass, onDrop: this.handleOnDrop.bind(this), accept: 'audio/wav' },
            React.createElement("span", { className: "" + dropzoneErrorClass }, this.state.dropzoneText)));
    };
    return FileLoader;
}(React.Component));
exports.default = FileLoader;
//# sourceMappingURL=file-loader.js.map