"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var types_1 = require("../common/types");
var Navigation = /** @class */ (function (_super) {
    __extends(Navigation, _super);
    function Navigation(props) {
        var _this = _super.call(this, props) || this;
        _this.handleInputChange = function (event) {
            _this.setState({ inputValue: event.currentTarget.value });
        };
        _this.submitNewBufferIndex = function () {
            _this.props.handleIncrement(_this.state.inputValue - _this.props.readOnlyBufferIndex);
        };
        _this.state = {
            inputValue: props.readOnlyBufferIndex
        };
        return _this;
    }
    Navigation.prototype.componentWillReceiveProps = function (props) {
        if (props.readOnlyBufferIndex !== this.state.inputValue) {
            this.setState({ inputValue: props.readOnlyBufferIndex });
        }
    };
    Navigation.prototype.render = function () {
        var _this = this;
        var positionClass = this.props.normalVisualizationStyle
            ? 'ffb-navigation-topRight'
            : 'ffb-navigation-bottomLeft';
        var renderButtons = function () { return (React.createElement("div", { className: "ffb-navigation " + positionClass },
            React.createElement("div", { className: "ffb-navigation-buttons" },
                React.createElement("input", { type: "number", value: _this.state.inputValue, onChange: _this.handleInputChange, onBlur: _this.submitNewBufferIndex, onKeyPress: function (event) { return (event.key === 'Enter') && _this.submitNewBufferIndex(); } }),
                React.createElement("button", { className: "ffb-button", onClick: function () { return _this.props.handleIncrement(-20); } }, "-20"),
                React.createElement("button", { className: "ffb-button", onClick: function () { return _this.props.handleIncrement(-1); } }, "-1"),
                React.createElement("button", { className: "ffb-button", onClick: function () { return _this.props.togglePlay(); } }, _this.props.audioGraphStatus === types_1.AudioGraphStatus.Connected ? 'Pause' : 'Play'),
                React.createElement("button", { className: "ffb-button", onClick: function () { return _this.props.handleIncrement(1); } }, "+1"),
                React.createElement("button", { className: "ffb-button", onClick: function () { return _this.props.handleIncrement(20); } }, "+20"),
                React.createElement("button", { className: "ffb-button", onClick: function () { return _this.props.toggleIsLooping(); } }, _this.props.isLooping ? 'No Loop' : 'Loop')))); };
        switch (this.props.audioFileStatus) {
            default:
            case types_1.AudioFileStatus.Uninitiated:
                return null;
            case types_1.AudioFileStatus.Loading:
                return React.createElement("div", null, "Loading...");
            case types_1.AudioFileStatus.Ready:
                return renderButtons();
        }
    };
    return Navigation;
}(React.Component));
exports.default = Navigation;
//# sourceMappingURL=navigation.js.map