/// <reference types="react" />
import * as React from 'react';
import AudioFile from './audio-engine/audio-file';
import AudioGraph from './audio-engine/audio-graph';
import { AudioFileStatus, AudioGraphStatus } from './common/types';
export interface FFTFlipBookProps {
    width: number;
    height: number;
}
export interface FFTFlipBookState {
    audioGraph: AudioGraph;
    readOnlyBufferIndex: number;
    audioFileStatus: AudioFileStatus;
    audioGraphStatus: AudioGraphStatus;
    normalVisualizationStyle: boolean;
    isLooping: boolean;
}
export default class FFTFlipBook extends React.Component<FFTFlipBookProps, FFTFlipBookState> {
    audioFile: AudioFile;
    constructor(props: FFTFlipBookProps);
    componentDidMount(): void;
    updateReadOnlyBufferIndex: (newIndex: number) => void;
    handleTogglePlay: () => void;
    handleResetGraphToDefaultState: () => void;
    handleLoadFile: (file: any) => void;
    handleToggleIsLooping: () => void;
    renderButtonsAndDropzone: () => JSX.Element;
    render(): JSX.Element;
}
